// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "fullscreen.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{

// Save current state of screensaver, and deactivate:
   SystemParametersInfo(SPI_GETSCREENSAVEACTIVE, 0, &ScreenSaverOn,FALSE);
   SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, FALSE, NULL,TRUE);

// Save current state of poweroff, and deactivate:
   SystemParametersInfo(SPI_GETPOWEROFFACTIVE, 0, &PowerOffOn,FALSE);
   SystemParametersInfo(SPI_SETPOWEROFFACTIVE, FALSE, NULL,TRUE);

// Save current state of low power, and deactivate:
   SystemParametersInfo(SPI_GETLOWPOWERACTIVE, 0, &LowPowerOn,FALSE);
   SystemParametersInfo(SPI_SETLOWPOWERACTIVE, FALSE, NULL,TRUE);

}

CMainFrame::~CMainFrame()
{
// retore screen saver to previous state
   SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, ScreenSaverOn, NULL,TRUE);
// retore power off to previous state
   SystemParametersInfo(SPI_SETPOWEROFFACTIVE, PowerOffOn, NULL,TRUE);
// retore low power to previous state
   SystemParametersInfo(SPI_SETLOWPOWERACTIVE, LowPowerOn, NULL,TRUE);
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

    CFullscreenApp *f=(CFullscreenApp *)AfxGetApp( );
    const CWnd * pW;
    if (f->top) pW=&wndTopMost;
    else pW=NULL;

    SetWindowPos(pW,f->x0 -1 ,f->y0 -1,f->width+3,f->height+3,SWP_SHOWWINDOW);

    // for icon
    m_wndInvisible.SetIcon(AfxGetApp( )->LoadIcon(IDR_MAINFRAME),TRUE);// if no taskbar
    //SetIcon(AfxGetApp( )->LoadIcon(IDR_MAINFRAME),TRUE);// if taskbar

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;


    // no taskbar
    // Create invisible window
     if (!::IsWindow(m_wndInvisible.m_hWnd))
     {
        LPCTSTR pstrOwnerClass = AfxRegisterWndClass(0);
        if (!m_wndInvisible.CreateEx(0, pstrOwnerClass, _T(""), WS_POPUP,
                CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
                NULL, 0))
            return FALSE;
     }

    cs.hwndParent = m_wndInvisible.m_hWnd;
    // no taskbar

    cs.style = WS_POPUP;
    cs.hMenu = NULL;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

